=== debian/changelog ===
utox (0.17.1-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.4.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Fri, 27 Sep 2019 21:44:24 +0800
