=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk


%:
	dh $@

# disable link time optimizations if compiling takes too long
# -DENABLE_LTO=OFF
override_dh_auto_configure:
	dh_auto_configure -- \
		-DENABLE_ASAN=OFF \
		-DENABLE_FILTERAUDIO=OFF \
		-DENABLE_TESTS=ON \
		-DENABLE_LTO=OFF
