## utox 0.17.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,10 @@
 
 set(PROJECT_VERSION_MAJOR "0")
 set(PROJECT_VERSION_MINOR "17")
-set(PROJECT_VERSION_PATCH "1")
+set(PROJECT_VERSION_PATCH "2")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
-set(PROJECT_COPYRIGHT "Copyleft 2019 uTox contributors. Some rights reserved.")
+set(PROJECT_COPYRIGHT "Copyleft 2020 uTox contributors. Some rights reserved.")
 
 string(TIMESTAMP BUILD_YEAR "%Y" UTC)
 string(TIMESTAMP BUILD_MONTH "%B" UTC)
@@ -80,13 +80,17 @@
 # Options #
 ###########
 
-option(UTOX_STATIC        "Link uTox statically"                                 ${STATIC_DEFAULT} )
-option(TOXCORE_STATIC     "Build uTox with the static version of Toxcore"        ${STATIC_DEFAULT} )
+option(STATIC_ALL         "Enable all STATIC_* options"                          ${STATIC_DEFAULT} )
+option(STATIC_TOXCORE     "Link toxcore statically"                              ${STATIC_DEFAULT} )
+option(STATIC_DBUS        "Link dbus statically"                                 ${STATIC_DEFAULT} )
+option(STATIC_FILTERAUDIO "Link filteraudio statically"                          ${STATIC_DEFAULT} )
+option(STATIC_OPUS        "Link opus statically"                                 ${STATIC_DEFAULT} )
+option(STATIC_SODIUM      "Link sodium statically"                               ${STATIC_DEFAULT} )
+option(STATIC_VPX         "Link vpx statically"                                  ${STATIC_DEFAULT} )
 option(ENABLE_ASAN        "Enable Address Sanitizer on debug builds"               ${ASAN_DEFAULT} )
 option(ENABLE_TESTS       "Whether to build test binaries (currently Unix-like OSes only)"      ON )
 option(ENABLE_WERROR      "Error on Warning, whether to put -Werror flag to the compiler"       OFF)
 option(ENABLE_FILTERAUDIO "Enable Filter Audio"                                                 ON )
-option(ENABLE_AUTOUPDATE  "Enable Auto-updater"                                                 OFF)
 option(ENABLE_LTO         "Enable link time optimizations"                                      ON )
 
 
@@ -151,9 +155,6 @@
     endif()
 endfunction()
 
-# Grab environment CFLAGS.
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} $ENV{CFLAGS}")
-
 # Warn on non-ISO C.
 #add_cflag("-pedantic") # throws a lot of warning, quite sure we do not want this at current state.
 ## Add all warning flags we can.
@@ -172,6 +173,9 @@
 ## Everything Else
 add_cflag("-fno-strict-aliasing")
 add_cflag("-fPIC")
+if(NOT WINDOWS) # TODO fix windows
+    add_cflag("-fno-common")
+endif()
 
 ## Optimization Flags
 
@@ -253,16 +257,12 @@
     add_cflag("-Werror")
 endif()
 
-if(UTOX_STATIC)
+if(STATIC_ALL)
     if(UNIX)
         add_cflag("-Wl -Bstatic -lopus -lopenal -lfilteraudio -Bdynamic -lrt -lm -lpthread -ldl")
     else()
         add_cflag("-static")
     endif()
-endif()
-
-if(ENABLE_AUTOUPDATE)
-    add_cflag("-DENABLE_AUTOUPDATE=1")
 endif()
 
 if(ENABLE_FILTERAUDIO)
@@ -362,11 +362,11 @@
     src/stb.c
     src/text.c
     src/theme.c
+    src/theme_tables.c
     src/tox.c
     src/tox_callbacks.c
     src/ui.c
     src/ui_i18n.c
-    src/updater.c
     src/utox.c
     src/window.c
     third-party/minini/dev/minIni.c
@@ -388,9 +388,3 @@
 set_property(TARGET utox PROPERTY C_STANDARD 11)
 
 if(APPLE)
-    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
-    # check that the app is valid and when the app is static
-    # also check that it does not depend on external libs (system libs excepted)
-    install(CODE "include(BundleUtilities)
-        verify_app(${CMAKE_BINARY_DIR}/utox.app)
-        if(UTOX_STATIC OR TOXCORE_STATIC)
