=== src/ui/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
     button.c
     contextmenu.c
     contextmenu.h
+    draw.c
     draw.h
     dropdown.c
     dropdown.h
