=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Yangfl <mmyangfl@gmail.com>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  cmake,
  check,
  libvpx-dev,
@@ -17,7 +17,8 @@
  libstb-dev,
  libminini-dev,
  libqrcodegen-dev,
-Standards-Version: 4.4.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://utox.io
 Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox
