=== debian/rules ===
--- 
+++ 
@@ -5,14 +5,14 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
-
-include /usr/share/dpkg/pkg-info.mk
-include /usr/share/dpkg/architecture.mk
+export DEB_LDFLAGS_MAINT_APPEND =
 
 
 %:
 	dh $@
+
+execute_after_dh_clean:
+	$(RM) src/cocoa/Info.plist src/utox.1
 
 # disable link time optimizations if compiling takes too long
 # -DENABLE_LTO=OFF
