=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,pgpsigurlmangle=s%archive/v(\d[\d.]*)\.tar\.gz%releases/download/v$1/v$1.tar.gz.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
