## utox 0.18.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,11 @@
 #####################
 
 set(PROJECT_VERSION_MAJOR "0")
-set(PROJECT_VERSION_MINOR "17")
-set(PROJECT_VERSION_PATCH "2")
+set(PROJECT_VERSION_MINOR "18")
+set(PROJECT_VERSION_PATCH "1")
 set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")
 
-set(PROJECT_COPYRIGHT "Copyleft 2020 uTox contributors. Some rights reserved.")
+set(PROJECT_COPYRIGHT "Copyleft 2021 uTox contributors. Some rights reserved.")
 
 string(TIMESTAMP BUILD_YEAR "%Y" UTC)
 string(TIMESTAMP BUILD_MONTH "%B" UTC)
@@ -29,16 +29,16 @@
 if(WIN32)
     set(WINDOWS TRUE)
 elseif(APPLE)
-    if(CMAKE_SYSTEM_NAME MATCHES ".*MacOS.*")
+    if(CMAKE_SYSTEM_NAME MATCHES "MacOS")
         set(CMAKE_OSX_DEPLOYMENT_TARGET 10.6 CACHE STRING "Minimum OS X deployment version")
         set(MACOSX TRUE)
     endif()
 elseif(UNIX)
-    if(CMAKE_SYSTEM_NAME MATCHES ".*Linux")
+    if(CMAKE_SYSTEM_NAME MATCHES "Linux")
         set(LINUX TRUE)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "kNetBSD.*|NetBSD.*")
+    elseif(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
         set(NETBSD TRUE)
-    elseif(CMAKE_SYSTEM_NAME MATCHES "kFreeBSD.*|FreeBSD")
+    elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
         set(FREEBSD TRUE)
     endif()
 endif()
@@ -122,8 +122,8 @@
                ${uTox_SOURCE_DIR}/src/cocoa/Info.plist)
 configure_file(${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml.in
                ${uTox_SOURCE_DIR}/src/android/AndroidManifest.xml)
-configure_file(${uTox_SOURCE_DIR}/src/utox.1.in
-               ${uTox_SOURCE_DIR}/src/utox.1)
+configure_file(${uTox_SOURCE_DIR}/man/utox.1.in
+               ${uTox_SOURCE_DIR}/man/utox.1)
 
 if(${CMAKE_BUILD_TYPE} MATCHES Debug)
     execute_process(COMMAND git describe --abbrev=8 --dirty --always --tags
@@ -173,9 +173,7 @@
 ## Everything Else
 add_cflag("-fno-strict-aliasing")
 add_cflag("-fPIC")
-if(NOT WINDOWS) # TODO fix windows
-    add_cflag("-fno-common")
-endif()
+add_cflag("-fno-common")
 
 ## Optimization Flags
 
@@ -273,17 +271,17 @@
 include_directories(${LIBTOX_INCLUDE_DIRS})
 set(LIBRARIES ${LIBRARIES} ${LIBTOX_LIBRARIES})
 
-find_package(libsodium REQUIRED)
-include_directories(${LIBSODIUM_INCLUDE_DIRS})
-set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})
+if(STATIC_ALL OR STATIC_TOXCORE OR STATIC_SODIUM OR APPLE)
+    find_package(libsodium REQUIRED)
+    include_directories(${LIBSODIUM_INCLUDE_DIRS})
+    set(LIBRARIES ${LIBRARIES} ${LIBSODIUM_LIBRARIES})
+endif()
 
 find_package(libvpx REQUIRED)
 include_directories(${LIBVPX_INCLUDE_DIRS})
 set(LIBRARIES ${LIBRARIES} ${LIBVPX_LIBRARIES})
 
-include_directories(SYSTEM third-party/stb)
-include_directories(SYSTEM third-party/minini/dev)
-include_directories(SYSTEM third-party/qrcodegen/c)
+add_subdirectory(third_party)
 
 # Protip, you must use a different directory for each build target...
 # -DMAKE_TOOLCHAIN_FILE has no effect unless the target directory is empty
@@ -318,12 +316,10 @@
 endif()
 
 # Acquire 3rd party headers
-find_path(STBI_INCLUDE_DIR NAMES stb_image.h stb_image_write.h PATHS third-party/stb)
+find_path(STBI_INCLUDE_DIR NAMES stb_image.h stb_image_write.h PATHS third_party/stb/stb)
 if((NOT STBI_INCLUDE_DIR) OR (NOT EXISTS ${STBI_INCLUDE_DIR}))
     message("STBI not found")
-    execute_process(COMMAND git submodule update --init -- third-party/stb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
-    # set FOO_INCLUDE_DIR properly
-    set(STBI_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/third-party/stb/ CACHE PATH "stbi include directory")
+    execute_process(COMMAND git submodule update --init -- third_party/stb/stb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
 endif()
 
 
@@ -358,8 +354,6 @@
     src/screen_grab.c
     src/self.c
     src/settings.c
-    src/sized_string.h
-    src/stb.c
     src/text.c
     src/theme.c
     src/theme_tables.c
@@ -369,8 +363,6 @@
     src/ui_i18n.c
     src/utox.c
     src/window.c
-    third-party/minini/dev/minIni.c
-    third-party/qrcodegen/c/qrcodegen.c
 
     ${WINDOWS_ICON}
     ${APPLE_FILES}
@@ -383,8 +375,17 @@
     ${LIBRARIES}
     pthread
     m
+    stb
+    minini
+    qrcodegen
 )
 
 set_property(TARGET utox PROPERTY C_STANDARD 11)
 
 if(APPLE)
+    set_target_properties(utox PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${uTox_SOURCE_DIR}/src/cocoa/Info.plist")
+    # check that the app is valid and when the app is static
+    # also check that it does not depend on external libs (system libs excepted)
+    install(CODE "include(BundleUtilities)
+        verify_app(${CMAKE_BINARY_DIR}/utox.app)
+        if(STATIC_ALL OR STATIC_TOXCORE)
