=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -37,9 +37,4 @@
 # TODO add a cmake macro for adding tests, this will be too verbose if we add more.
 make_test(chatlog)
 
-if(ENABLE_AUTOUPDATE)
-  make_test(updater)
-      target_link_libraries(test_updater sodium)
-endif()
-
 make_test(chrono)
