=== third_party/CMakeLists.txt ===
add_cflag("-Wno-error")

add_subdirectory(minini)
add_subdirectory(qrcodegen)
add_subdirectory(stb)
