=== src/windows/CMakeLists.txt ===
--- 
+++ 
@@ -15,21 +15,21 @@
     events.c
     filesys.c
     main.c
-    main.h
     notify.c
     os_video.c
     screen_grab.c
     utf8.c
     video.c
     window.c
-
-    main.7.c
     )
 
 target_link_libraries(utoxNATIVE
-    iphlpapi    ws2_32      gdi32       msimg32
-    dnsapi      comdlg32    winmm       ole32
-    oleaut32    strmiids    shell32     opus
-    )
+    PUBLIC
+        iphlpapi    ws2_32      gdi32       msimg32
+        dnsapi      comdlg32    winmm       ole32
+        oleaut32    strmiids    shell32     opus
+    PRIVATE
+        stb
+)
 
 set(WINDOWS_ICON utox.rc)
