=== src/xlib/CMakeLists.txt ===
--- 
+++ 
@@ -24,19 +24,14 @@
 #########################################
 add_library(utoxNATIVE STATIC
     audio.c
-    dbus.c
-    dbus.h
+    $<$<BOOL:${ENABLE_DBUS}>:dbus.c>
     drawing.c
     event.c
     filesys.c
     freetype.c
-    freetype.h
     gtk.c
-    keysym2ucs.h
     main.c
-    main.h
-    mmenu.c
-    mmenu.h
+    $<$<BOOL:${ENABLE_UNITY_MMENU}>:mmenu.c>
     screen_grab.c
     tray.c
     v4l.c
@@ -75,6 +70,7 @@
 endif()
 
 target_link_libraries(utoxNATIVE
+    PUBLIC
         icon
         ${LIBV4LCONVERT_LIBRARIES}
         ${LIBFONTCONFIG_LIBRARIES}
@@ -82,18 +78,22 @@
         ${X11_Xrender_LIB}
         ${FREETYPE_LIBRARIES}
         ${DBUS_LIBRARIES}
-        )
+    PRIVATE
+        stb
+)
 
 if(LINUX OR NETBSD)
     target_link_libraries(utoxNATIVE
-        resolv
-        )
+        PUBLIC
+            resolv
+    )
 endif()
 
 if(LINUX)
     target_link_libraries(utoxNATIVE
-        dl
-        )
+        PUBLIC
+            dl
+    )
 endif()
 
 include(GNUInstallDirs)
@@ -104,7 +104,7 @@
     )
 
 install(FILES
-    ../utox.1
+    ../../man/utox.1
     DESTINATION "${CMAKE_INSTALL_MANDIR}/man1"
     )
