=== third_party/stb/CMakeLists.txt ===
project(stb LANGUAGES C)

add_library(${PROJECT_NAME} STATIC
    stb.c
)

target_include_directories(${PROJECT_NAME}
    SYSTEM PUBLIC .
)
