=== debian/changelog ===
utox (0.18.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Thu, 28 Jan 2021 17:48:20 +0800

utox (0.18.0-1) unstable; urgency=medium

  * New upstream release
    - Fix segfault on setting proxy settings (Closes: #942081)

 -- Yangfl <mmyangfl@gmail.com>  Tue, 08 Dec 2020 02:15:04 +0800
