=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  libqrcodegen-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
-Homepage: https://utox.io
+Homepage: https://utox.org
 Vcs-Git: https://salsa.debian.org/yangfl-guest/uTox.git
 Vcs-Browser: https://salsa.debian.org/yangfl-guest/uTox
