=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%uTox-$1.tar.gz%,downloadurlmangle=s%archive/v?(\d[\d.]*)\.tar\.gz%releases/download/v$1/uTox-$1-full.tar.gz%,pgpsigurlmangle=s%$%.asc%" \
   https://github.com/uTox/uTox/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
